var url_post_port = "/cgi-bin/drive_led_gpio.py";
var url_post_sensor = "/cgi-bin/get_weather-data_i2c.py";

var flgTime = false;
var timerHundle = null;

colorTable = {
    "LED1":"background-color:#00BCF9",
    "LED2":"background-color:#FFFF33",
    "LED3":"background-color:#FF3300",
    "OFF":"background-color:#FFFFFF"
 }

// サーバーにPOST送信するJSONデータを生成するクラス
class makeingPortStatJsonData{
    constructor() {
        this.portStat =  { 
        "LED1":"OFF",  "LED2":"OFF", "LED3":"OFF"
        };
        console.log(this.portStat);
        this.sensorStat =  { 
            "GET":"DUMMY",  "TEMP":0.00, "HUMI":0.00
            };
        console.log(this.sensorStat);
    }
    // 指定したLEDをONまたはOFFしてポートマップを作り、JSONデータを生成する。
    getJSON_port(portname){
        var before = Object.assign({}, this.portStat);
        if ( this.portStat[portname] === "OFF" ) {
            this.portStat[portname] = "ON";
        } else {
            this.portStat[portname] = "OFF";
        }
        console.log(before);
        console.log(this.portStat);
        var json_data = JSON.stringify(this.portStat);
        return json_data;
    }
    // GET命令と温度と湿度データを受け取る箱からなるマップを作り、JSONデータを生成する。
    getJSON_sensor(){
        var json_data = JSON.stringify(this.sensorStat);
        return json_data;
    }
}

PortStatJsonData = new makeingPortStatJsonData();

// clickイベント処理
document.body.addEventListener("click", function(event){
        var eventClass = event.target.className;
        if ( eventClass === "PORT" ) { 
            // LED制御テスト画面からの、LED番号指定によるJSONデータの生成と、POST送信
            var json_data = PortStatJsonData.getJSON_port(event.target.id);
            xhrPost_port(url_post_port, json_data);
        }
} ,false);

var json_data = PortStatJsonData.getJSON_sensor();
if(flgTime == false) {
	timerHundle = setInterval(xhrPost_sensor, 1000, url_post_sensor, json_data);
	flgTime = true;
}
window.onbeforeunload = function(e) {
	if(flgTime) {
		clearInterval(timerHundle);
	}
}
   
function xhrPost_port(url, jsondata) {
    // XHRの宣言
    var XHR = new XMLHttpRequest();
    // openメソッドにPOSTを指定して送信先のURLを指定する
    XHR.open("POST", url, true);
    
    // sendメソッドにデータを渡して送信を実行する
    XHR.setRequestHeader('Context-Type', 'application/json');
    XHR.send( jsondata );
    
    // サーバの応答をonreadystatechangeイベントで検出して正常終了したらデータを取得する
    XHR.onreadystatechange = function(){
        if(XHR.readyState == 4 && XHR.status == 200){
            // POST送信した結果を表示する
            // サーバーが返したjsonデータを用いてボタンの色（状態）を変える
            let responseJson = JSON.parse(XHR.response);
            for( var key in responseJson ) {
                if ( responseJson[key] === "ON" ) {
                    document.getElementById(key).style= colorTable[key];
                } else {
                    document.getElementById(key).style= colorTable["OFF"];
                }                                                                      
            }          
        } else {

        }
    };
}

function xhrPost_sensor(url, jsondata) {
    // XHRの宣言
    var XHR = new XMLHttpRequest();
    // openメソッドにPOSTを指定して送信先のURLを指定する
    XHR.open("POST", url, true);
    
    // sendメソッドにデータを渡して送信を実行する
    XHR.setRequestHeader('Context-Type', 'application/json');
    XHR.send( jsondata );
    
    // サーバの応答をonreadystatechangeイベントで検出して正常終了したらデータを取得する
    XHR.onreadystatechange = function(){
        if(XHR.readyState == 4 && XHR.status == 200){
            // POST送信した結果を表示する
            // サーバーが返したjsonデータを用いて温度や湿度を表示する。
            let responseJson = JSON.parse(XHR.response);
                for( var key in responseJson ) {
                    if ( (key === "TEMP") || (key ==="HUMI" ) ) {
                        document.getElementById(key).innerHTML = (responseJson[key]).toFixed(2);
                    }                                                                                          
                }
        } else {

        }
    };
}