#!/usr/bin/env python
# デバッグ用
import cgitb
cgitb.enable()

import cgi
import json
import sys
import time
import RPi.GPIO as GPIO

print("Content-Type: text/plain")
print()

# Setting GPIO condition
GPIO.setmode(GPIO.BCM)
blueLED = 22 # call GPIO22 blueLED
yellowLED = 23 # call GPIO23 blueLED
redLED = 24 # call GPIO24 blueLED
GPIO.setup(blueLED, GPIO.OUT)
GPIO.setup(yellowLED, GPIO.OUT)
GPIO.setup(redLED, GPIO.OUT)

LED_TABLE = {
                "LED":{"LED1":blueLED, "LED2":yellowLED, "LED3":redLED},
                "ONOFF":{"ON":True, "OFF":False}
            }

# cgiとして外部からの標準入力でデータを受け取って動作させる前に、キー入力でLEDの点灯消灯ができるかテストを行う。
# cmd = ""
# while cmd != "finish":
#     cmd = input("input cmd or finish:")
#     if cmd == "blue_on":
#         GPIO.output(blueLED, True)
#         time.sleep(1)
#         GPIO.output(blueLED, False)
#     elif cmd == "yellow_on":
#         GPIO.output(yellowLED, True)
#         time.sleep(1)
#         GPIO.output(yellowLED, False)
#     elif cmd == "red_on":
#         GPIO.output(redLED, True)
#         time.sleep(1)
#         GPIO.output(redLED, False)
#     else:
#         print("unknown command")

data = sys.stdin.read()
cmd_json = json.loads(data)

# jsonデータからkeyを取り出して指定するLEDを点灯または消灯させる 
for key in cmd_json:
    GPIO.output(LED_TABLE.get("LED").get(key), LED_TABLE.get("ONOFF").get(cmd_json[key]))

# 受け取ったJSONデータをループバックする。ブラウザ側ではこちらのjsonデータが届いたことの確認の印としてJSONデータを受け取る。
print(json.dumps(cmd_json))
